﻿using System.Windows;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 펜
        /// </summary>
        private Pen pen;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.pen = new Pen(Brushes.Blue, 10);

            this.pen.Freeze();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 렌더링시 처리하기 - OnRender(drawingContext)

        /// <summary>
        /// 렌더링시 처리하기
        /// </summary>
        /// <param name="drawingContext">그리기 컨텍스트</param>
        protected override void OnRender(DrawingContext drawingContext)
        {
            drawingContext.DrawRectangle
            (
                Brushes.White,
                null,
                new Rect
                (
                    0,
                    0,
                    this.grid.ActualWidth,
                    this.grid.ActualHeight
                )
            );

            Rect rectangle = new Rect
            (
                100,
                100,
                this.grid.ActualWidth  - 200,
                this.grid.ActualHeight - 200
            );

            drawingContext.DrawRoundedRectangle(Brushes.LightBlue, this.pen, rectangle, 50, 50);
        }

        #endregion
    }
}